/* Exception handlers - Must be 32 bytes long. */
    .section    .boot, "ax", @progbits
    .global     _start  
_start:
_reset_handler:
    xor   r0, r0, r0
    wcsr ie, r0
    bi   .MainPrg
    nop
    nop
    nop
    nop
    nop
_breakpoint_handler:
    rcsr r7, DEBA
    addi r7, r7, 32
    b    r7
    nop
    nop
    nop
    nop
    nop
_instruction_bus_error_handler:
    rcsr r7, DEBA
    addi r7, r7, 64
    b    r7
    nop
    nop
    nop
    nop
    nop
_watchpoint_handler:
    rcsr r7, DEBA
    addi r7, r7, 96
    b    r7
    nop
    nop
    nop
    nop
    nop
_data_bus_error_handler:
    rcsr r7, DEBA
    addi r7, r7, 128
    b    r7
    nop
    nop
    nop
    nop
    nop
_divide_by_zero_handler:
    rcsr r7, DEBA
    addi r7, r7, 160
    b    r7
    nop
    nop
    nop
    nop
    nop
_interrupt_handler:
    nop
    nop
    nop
    nop
	nop
    nop
    nop
    nop
_system_call_handler:
    rcsr r7, DEBA
    addi r7, r7, 224
    b    r7
    nop
    nop
    nop
    nop
    nop
_crt0:
.MainPrg:
	xor r1,  r1, r1
	xor r2,  r2, r2
	xor r3,  r3, r3
	xor r4,  r4, r4
	xor r5,  r5, r5
    xor r6,  r6, r6
    xor r7,  r7, r7
    /*******************************************************************/
    /*                                                                 */
    /* Load 0xffffffff in R3, 4 in R6                                  */
    /*                                                                 */
    /*******************************************************************/
    addi r3, r0, -1
    addi r6, r0, 4
    /*******************************************************************/
    /*                                                                 */
    /* Determine entry address (R7)                                    */
    /*                                                                 */
    /*******************************************************************/
    orhi r2, r0, hi(entry_address)
    ori  r2, r2, lo(entry_address)
    lw   r7, (r2+0)
.LoadSectionInfo:
    /*******************************************************************/
    /*                                                                 */
    /* Get length of section (R1)                                      */
    /*                                                                 */
    /*******************************************************************/
    addi r2, r2, 4
    lw   r1, (r2+0)
    /*******************************************************************/
    /*                                                                 */
    /* Check if all sections are loaded                                */
    /*                                                                 */
    /*******************************************************************/
    be   r3, r1, .StartProgram
    /*******************************************************************/
    /*                                                                 */
    /* Get address where this section's data is to be loaded (R4)      */
    /* Assumed that the starting address is on a 4-byte boundary       */
    /*                                                                 */
    /*******************************************************************/
    addi r2, r2, 4
    lw   r4, (r2+0)
    /*******************************************************************/
    /*                                                                 */
    /* Load section                                                    */
    /*                                                                 */
    /*******************************************************************/    
.LoadSection:
    be   r1, r0, .LoadSectionInfo
    addi r2, r2, 4
    lw   r5, (r2+0)
    sw   (r4+0), r5
    addi r1, r1, -4
    addi r4, r4, 4
    bi  .LoadSection
    /*******************************************************************/
    /*                                                                 */
    /* Jump to program                                                 */
    /*                                                                 */
    /*******************************************************************/
.StartProgram:
    b    r7

#include "BinData.S"
